﻿using System;
using System.Globalization;
using System.Windows.Data;
using System.Windows.Markup;

namespace DocTools.WPF.Extensions
{
    [MarkupExtensionReturnType(typeof(IValueConverter))]
    public class UpdateTimeConverterExtension : MarkupExtension
    {
        private UpdateTimeConverter _converter;

        public override object ProvideValue(IServiceProvider serviceProvider)
        {
            return _converter ?? (_converter = new UpdateTimeConverter());
        }

        private class UpdateTimeConverter : IValueConverter
        {
            public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
            {
                if (value is DateTime)
                {
                    return ((DateTime)value).ToLocalTime().ToString("yyyy/MM/dd HH:mm:ss");
                }
                return "";
            }

            public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
            {
                throw new NotImplementedException();
            }
        }
    }
}