﻿using System.Collections.Generic;

namespace DocTools.Entity.Doc
{
    public class ResponseEntity
    {
        public ResponseResultEntity error { get; set; } = new ResponseResultEntity();
        public ResponseResultEntity success { get; set; } = new ResponseResultEntity();
    }

    public class ResponseParameterEntity
    {
        public string description { get; set; } = string.Empty;

        public int is_checked { get; set; } = 0;

        public string key { get; set; } = string.Empty;

        public string type { get; set; } = string.Empty;

        public string not_null { get; set; } = string.Empty;

        public string field_type { get; set; } = string.Empty;

        public object value { get; set; } = string.Empty;
        //0表示默认，啥也不干，1-表示为enum类型
        public int field_type_value { get; set; } = 0;
        public string field_type_target_id { get; set; } = string.Empty;
        public string file_name { get; set; } = string.Empty;
    }

    public class ResponseResultEntity
    { 
        public string raw { get; set; } = string.Empty;
        public List<ResponseParameterEntity> parameter { get; set; } = new List<ResponseParameterEntity>();

        public List<ExceptionResultEntity> error_result { get; set; } = new List<ExceptionResultEntity>();
    }

    public class ExceptionResultEntity
    {
        public string title { get; set; } = string.Empty;

        public string name { get; set; } = string.Empty;

        public string url { get; set; } = string.Empty;

        public List<string> header { get; set; } = new List<string>();

        public List<ExceptionContentEntity> content { get; set; } = new List<ExceptionContentEntity>();
    }

    public class ExceptionContentEntity
    {
        public List<string> content_data { get; set; } = new List<string>();
    }
}
