﻿using System.Collections.Generic;

namespace DocTools.Entity.Doc
{
    public class ResultEntity
    {
        public string create_time { get; set; } = string.Empty;
        public string id { get; set; } = string.Empty;
        public string name { get; set; } = string.Empty;
        public string project_id { get; set; } = string.Empty;
        public string project_name { get; set; } = string.Empty;
        public string publisher { get; set; } = string.Empty;
        public string target_id { get; set; } = string.Empty;
        public string target_type { get; set; } = string.Empty;
        public ProjectEntity project { get; set; } = new ProjectEntity();
        public List<FolderChildrenEntity> targets { get; set; } = new List<FolderChildrenEntity>();
    }

    public class ProjectEntity
    {
        public List<EnvEntity> envs { get; set; } = new List<EnvEntity>();
        public VarsEntity vars { get; set; } = new VarsEntity();
    }

    public class EnvEntity
    { 
        public string env_id { get; set; } = string.Empty;
        public string name { get; set; } = string.Empty;
        public NullParameterEntity list { get; set; } = new NullParameterEntity();
    }

    public class VarsEntity
    {
        public List<NullParameterEntity> variable { get; set; } = new List<NullParameterEntity>();
        public List<string> methods { get; set; } = new List<string>();
        public ScriptEntity script { get; set; } = new ScriptEntity();
        public List<MarkEntity> mark { get; set; } = new List<MarkEntity>();
        public VarsRequestEntity request { get; set; } = new VarsRequestEntity();
    }

    public class MarkEntity
    { 
        public string key { get; set; } = string.Empty;
        public string name { get; set; } = string.Empty;
    }

    public class VarsRequestEntity
    {
        public List<ResponseParameterEntity> body { get; set; } = new List<ResponseParameterEntity>();
        public List<ResponseParameterEntity> cookie { get; set; } = new List<ResponseParameterEntity>();
        public List<ResponseParameterEntity> header { get; set; } = new List<ResponseParameterEntity>();
        public List<ResponseParameterEntity> query { get; set; } = new List<ResponseParameterEntity>();
    }
}
