﻿using System.Collections.Generic;

namespace DocTools.Entity
{
    public class MethodBasicEntity
    {
        public string MethodNameSpace { get; set; } = string.Empty;
        public string InterfaceName { get; set; } = string.Empty;
        public string MethodName { get; set; } = string.Empty;
        public string Summary { get; set; } = string.Empty;
        public string Returns { get; set; } = string.Empty;
        public string Value { get; set; } = string.Empty;
        public string ReturnsTypeFullName { get; set; } = string.Empty;
        public string ParamName { get; set; } = string.Empty;
        public string ParamTypeFullName { get; set; } = string.Empty;
        public string ParamText { get; set; } = string.Empty;
        public string SubmitType { get; set; } = "POST";
        public string ErrorCodes { get; set; } = string.Empty;

        public List<ParamPropertyEntity> RequestList = new List<ParamPropertyEntity>();

        public List<ParamPropertyEntity> ResponseList = new List<ParamPropertyEntity>();        
    }

    public class ParamPropertyEntity
    { 
        public string Desc { get; set; } = string.Empty;
        public string DefaultValue { get; set; } = string.Empty;
        public string Name { get; set; } = string.Empty;
        public string TypeFullName { get; set; } = string.Empty;
        /// <summary>
        /// 针对 TypeFullName 为泛型时，T的类型
        /// </summary>
        public string GenericityType { get; set; } = string.Empty;

        /// <summary>
        /// 是否必填，默认必填1-必填，0-非必填
        /// </summary>
        public string IsNotNull { get; set; } = "1";
        //本身还有子项
        public List<ParamPropertyEntity> ParamPropertyList = new List<ParamPropertyEntity>();
    }
}
