﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DocTools.Entity.Parameters
{
    /// <summary>
    /// Parameters interface, different type can implement it
    /// </summary>
    public interface IParameter
    {
        /// <summary>
        /// parameter name
        /// </summary>
        string Name { get; set; }

        /// <summary>
        /// parameter section
        /// </summary>
        string Section { get; set; }

        /// <summary>
        /// parameter value changed state
        /// </summary>
        bool IsChanged { get; }

        /// <summary>
        /// change initial value
        /// </summary>
        void ChangeInitialValue();

        void ChangeSavedValue();

        /// <summary>
        /// Load user setting value
        /// </summary>
        /// <param name="value">User setting value.</param>
        void ChangeParameterValue(object value);
    }
}
